LeetCode 448. 找到所有数组中消失的数字
作者:互联网
LeetCode 448. 找到所有数组中消失的数字
一、题目详情
原题链接:https://leetcode-cn.com/problems/find-all-numbers-disappeared-in-an-array/
给定一个范围在 1 ≤ a[i] ≤ n
( n = 数组大小 ) 的 整型数组,数组中的元素一些出现了两次,另一些只出现一次。
找到所有在 [1, n]
范围之间没有出现在数组中的数字。
您能在不使用额外空间且时间复杂度为O(n)
的情况下完成这个任务吗? 你可以假定返回的数组不算在额外空间内。
示例:
输入:
[4,3,2,7,8,2,3,1]
输出:
[5,6]
二、HashMap法
可以使用HashMap解决本题。先遍历一遍数组,将数组中的数据通过key-value
方式存到map中,然后再遍历一次[1, n]
范围,若map中不存在该数字,则添加到list中,最终返回list。
class Solution {
public List<Integer> findDisappearedNumbers(int[] nums) {
List<Integer> list = new ArrayList<>();
Map<Integer,Integer> map = new HashMap<>();
for(int i = 0;i < nums.length;i++){
map.put(nums[i],1);
}
for(int i = 1;i <= nums.length;i++){
if(!map.containsKey(i)){
list.add(i);
}
}
return list;
}
}
三、原地修改法
class Solution {
public List<Integer> findDisappearedNumbers(int[] nums) {
int n = nums.length;
// 遍历数组,把值对应的下标加n,后续数组大于n的下标表示存在的值
for (int num : nums) {
// 计算出下标,因为是取余,所以就算这个位置之前有加过n,取余之后也不会影响原来的值,
int x = (num - 1) % n;
// 下标对应的值+1
nums[x] += n;
}
// 存放结果数组
List<Integer> ret = new ArrayList<Integer>();
// 遍历数组,把没有出现过的数组添加到结果数组中
for (int i = 0; i < n; i++) {
// 因为存在的值都会加在对应数组下标上面加上n,所以肯定大于n
if (nums[i] <= n) {
ret.add(i + 1);
}
}
return ret;
}
}
标签:map,448,下标,nums,int,list,数组,LeetCode 来源: https://blog.csdn.net/jrrhjww/article/details/117295476